//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;

char *strNames[] = {
   "Kirk",
   "Spock",
   "McCoy",
   "Uhura",
   "Sulu",
   "Chekov",
   "Scotty",
   "Riley"
};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   m_nClick = 0;
   m_pPrevButton = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::HandleButtonClick(TObject *Sender)
{
TButton *pButton = static_cast<TButton *>(Sender);
	if ( m_nClick == 1) //  
	{
		//   
		m_nClick = 0;
		if ( m_pPrevButton == NULL )
			return;

		//    
		if ( m_pPrevButton->Caption == pButton->Caption )
		{
			m_pPrevButton->Hide();
			pButton->Hide();
		}
		else
		{
		MessageBeep(MB_ICONEXCLAMATION);
		}
	}
	else
	{
		//  
		m_nClick = 1;
		//  
		m_pPrevButton = pButton;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    int nStringIndex = 0;
    for ( int i=0; i<ControlCount; ++i )
    {
       TButton *pButton = dynamic_cast<TButton *>(Controls[i]);
       if ( pButton )
       {
          pButton->Caption = strNames[ nStringIndex ];
          nStringIndex ++;
          if ( nStringIndex > 7 )
             nStringIndex = 0;
       }
    }
}
//---------------------------------------------------------------------------
