//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;

char *strNames[] = {
   "Kirk",
   "Spock",
   "McCoy",
   "Uhura",
   "Sulu",
   "Chekov",
   "Scotty",
   "Riley"
};

const MaxStringCount = 8;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   m_nClick = 0;
   m_pPrevButton = NULL;
}
//--------------------------------------------------------------------------- 
void __fastcall TForm1::HandleButtonClick(TObject *Sender)
{
	TButton *pButton = static_cast<TButton *>(Sender);
	if ( m_nClick == 1) //  
	{
		//   
		m_nClick = 0;
		if ( m_pPrevButton == NULL )
			return;

		//    
		if ( m_pPrevButton->Caption == pButton->Caption )
		{
			m_pPrevButton->Hide();
			pButton->Hide();
		}
		else
		{
		MessageBeep(MB_ICONEXCLAMATION);
		}
	}
	else
	{
		//  
		m_nClick = 1;
		//  
		m_pPrevButton = pButton;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    char strings_1[MaxStringCount*2][ 20 ];
    char strings_2[MaxStringCount*2][ 20 ];

	//      
	for ( int i=0; i<MaxStringCount; ++i )
	{
		strcpy ( strings_1[i], strNames[i]);
		strcpy ( strings_1[i+MaxStringCount], strNames[i]);
	}

	//      
	for ( int i=MaxStringCount*2-1; i>=0; --i )
	{
		int nInd = random( i);
		//      
		strcpy ( strings_2[i], strings_1[nInd] );
		//      
		strcpy ( strings_1[nInd], strings_1[i] );
	}

	int nStringIndex = 0;
	for ( int i=0; i<ControlCount; ++i )
	{
		TButton *pButton = dynamic_cast<TButton *>(Controls[i]);
		if ( pButton )
		{
			pButton->Caption = strings_2[ nStringIndex ];
			if ( nStringIndex < MaxStringCount*2-1 )
			nStringIndex ++;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SelectImage1Click(TObject *Sender)
{
  OpenDialog1->Filter = "   (*.bmp)|*.bmp";
  if ( OpenDialog1->Execute() )
  {
  	TPicture *pPicture = new TPicture;
  	pPicture->LoadFromFile( OpenDialog1->FileName );
  	Image1->Picture = pPicture;
  }
}
//---------------------------------------------------------------------------
